> ## Documentation Index
> Fetch the complete documentation index at: https://docs.tenbyte.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Create VM

> Create a new virtual machine. billing_account_id is optional if using an API token restricted to one billing account. Location-specific endpoint.



## OpenAPI

````yaml https://raw.githubusercontent.com/vidinfra/open-api-docs/refs/heads/main/cloud-api.json post /user-resource/vm
openapi: 3.0.0
info:
  title: Tenbyte Cloud API
  version: 1.0.0
  description: >-
    API for managing cloud resources like Virtual Machines, Storage, Networks,
    and more on tenbytecloud.com.
servers:
  - url: https://api.tenbytecloud.com/v1
    description: Production server
security:
  - apikey-header-apikey: []
tags:
  - name: User
    description: User profile and SSH key management
  - name: Token
    description: API token management
  - name: Locations
    description: Available data centre locations
  - name: VM
    description: Virtual machine management
  - name: Block Storage
    description: Block storage disk management
  - name: Object Storage
    description: S3-compatible object storage management
  - name: Private networks
    description: Private network management
  - name: Floating IP
    description: Floating IP address management
  - name: Firewall
    description: Firewall management
  - name: Network Load Balancer
    description: Network load balancer management
  - name: Parameters
    description: VM creation parameters and image lists
paths:
  /user-resource/vm:
    post:
      tags:
        - VM
      summary: Create VM
      description: >-
        Create a new virtual machine. billing_account_id is optional if using an
        API token restricted to one billing account. Location-specific endpoint.
      operationId: createVm
      requestBody:
        content:
          application/x-www-form-urlencoded:
            schema:
              type: object
              properties:
                backup:
                  type: boolean
                  default: false
                billing_account_id:
                  type: integer
                description:
                  type: string
                designated_pool_uuid:
                  type: string
                  description: Resource pool to allocate this VM into
                disks:
                  type: string
                name:
                  type: string
                os_name:
                  type: string
                os_version:
                  type: string
                password:
                  type: string
                public_key:
                  type: string
                  description: OpenSSH public key line
                public_keys:
                  type: string
                  description: Multiple SSH public keys
                ram:
                  type: integer
                source_replica:
                  type: string
                source_uuid:
                  type: string
                username:
                  type: string
                vcpu:
                  type: integer
                reserve_public_ip:
                  type: boolean
                  default: true
                network_uuid:
                  type: string
                cloud_init:
                  type: string
                  description: JSON or YAML cloud-init user-data
                disk_uuid:
                  type: string
      responses:
        '200':
          description: Created VM
          content:
            application/json:
              schema:
                type: object
              example:
                billing_account: 6
                name: Ubuntu-16-04
                os_name: ubuntu
                os_version: '16.04'
                status: running
                uuid: fc880f74-cf03-4a7a-93da-74c506157023
                vcpu: 2
      security:
        - apikey-header-apikey: []
components:
  securitySchemes:
    apikey-header-apikey:
      type: apiKey
      in: header
      name: apikey

````